#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct node {
	vector<int> go;
	vector<int> on;
	int parent;
	bool ends_here;
	int cnt_children;
	bool press_letter;
	int val;
	node(int _parent) : go(26, -1), on(26), parent(_parent), ends_here(false), cnt_children(0), press_letter(false), val(0) {}

	void add_edge(int e) {
		on[e]++;
		if (on[e] == 1) {
			cnt_children++;
			if (cnt_children > 1 || ends_here) {
				press_letter = true;
			}
		}
	}

	void rem_edge(int e) {
		on[e]--;
		if (on[e] == 0) {
			cnt_children--;
			if (cnt_children == 0 || (cnt_children == 1 && !ends_here)) {
				press_letter = false;
			}
		}
	}

	void set_ends_here(bool _ends_here) {
		ends_here = _ends_here;
		if (ends_here && cnt_children) {
			press_letter = true;
		}
		if (!ends_here && cnt_children <= 1) {
			press_letter = false;
		}
	}
};

void solve() {
	vector<node> trie;
	trie.push_back(node(-1));
	int q;
	cin >> q;
	vector<string> all;
	vector<int> ends;
	vector<pii> reqs;
	for (int i = 0; i < q; ++i) {
		char c;
		cin >> c;
		if (c == '+') {
			string s;
			cin >> s;
			int cur = 0;
			for (char let : s) {
				if (trie[cur].go[let - 'a'] == -1) {
					trie[cur].go[let - 'a'] = szof(trie);
					trie.push_back(node(cur));
				}
				cur = trie[cur].go[let - 'a'];
			}
			reqs.push_back({0, szof(all)});
			all.push_back(s);
			ends.push_back(cur);
		} else if (c == '-') {
			int ind;
			cin >> ind;
			--ind;
			reqs.push_back({1, ind});
		} else {
			int ind;
			cin >> ind;
			--ind;
			reqs.push_back({2, ind});
		}
	}

	vector<int> tin(szof(trie)), tout(szof(trie));
	int tcnt = 0;
	function<void(int)> dfs = [&](int v) {
		tin[v] = tcnt++;
		for (int i = 0; i < 26; ++i) {
			if (trie[v].go[i] != -1) {
				dfs(trie[v].go[i]);
			}
		}
		tout[v] = tcnt;
	};

	dfs(0);

	int bpv = 1;
	while (bpv < tcnt) {
		bpv *= 2;
	}

	vector<int> rsq(bpv * 2);

	function<void(int, int, int)> rsq_segadd = [&](int l, int r, int val) {
		l += bpv;
		r += bpv;
		while (l < r) {
			if (l & 1) {
				rsq[l++] += val;
			}
			if (r & 1) {
				rsq[--r] += val;
			}
			l /= 2; r /= 2;
		}
	};

	function<int(int)> rsq_getval = [&](int pos) {
		pos += bpv;
		int ret = 0;
		while (pos) {
			ret += rsq[pos];
			pos /= 2;
		}
		return ret;
	};

	function<void(int)> update_val = [&](int v) {
		int val;
		if (trie[v].press_letter || (trie[v].cnt_children && trie[trie[v].parent].press_letter)) {
			val = 1;
		} else {
			val = 0;
		}
		rsq_segadd(tin[v], tout[v], val - trie[v].val);
		trie[v].val = val;
	};

	rsq_segadd(tin[0], tout[0], 1);

	for (pii req : reqs) {
		// cerr << req.ff << " " << req.ss << endl;
		if (req.ff == 0) {
			int cur = 0;
			for (char c : all[req.ss]) {
				trie[cur].add_edge(c - 'a');
				cur = trie[cur].go[c - 'a'];
			}
			trie[cur].set_ends_here(true);
			cur = 0;
			for (char c : all[req.ss]) {
				for (int i = 0; i < 26; ++i) {
					if (trie[cur].on[i]) {
						update_val(trie[cur].go[i]);
					}
				}
				cur = trie[cur].go[c - 'a'];
			}
			for (int i = 0; i < 26; ++i) {
				if (trie[cur].on[i]) {
					update_val(trie[cur].go[i]);
				}
			}
		} else if (req.ff == 1) {
			int cur = 0;
			for (char c : all[req.ss]) {
				trie[cur].rem_edge(c - 'a');
				cur = trie[cur].go[c - 'a'];
			}
			trie[cur].set_ends_here(false);
			cur = 0;
			for (char c : all[req.ss]) {
				for (int i = 0; i < 26; ++i) {
					if (trie[cur].on[i]) {
						update_val(trie[cur].go[i]);
					}
				}
				cur = trie[cur].go[c - 'a'];
			}
			for (int i = 0; i < 26; ++i) {
				if (trie[cur].on[i]) {
					update_val(trie[cur].go[i]);
				}
			}
		} else {
			cout << rsq_getval(tin[trie[ends[req.ss]].parent]) << "\n";
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
